
def list_example1():
    string = "Hello world !!?"
    print(string[1:3])
    print(string[-1])
    print(string[:2])

    str_list = string.split()
    print(str_list)
    print(str_list[1:3])
    print(str_list[-1])
    print(str_list[:2])
    print(str_list[0])


def list_example2():
    colors = ["red", "orange", "yellow", "green", "blue", "purple"]

    # fix rainbow
    colors[5] = "indigo"
    colors = colors + ["violet"]

    for color in colors:
        print(color)

    for i in range(len(colors)):
        print(colors[i])


def list_mutability_example1():
    a_list = [3.5, 6, [1, 2], "abc"]

    a_list.append("c")
    a_list.extend(["c", "b"])
    a_list[3] = 3.33333
    a_list[:2] = ["a", "b"]
    a_list.pop(3)
    del (a_list[0:1])
    print(a_list)
    x = ["a"].pop()
    print(x)

def list_mutability_example2():
    a_list = [3.5, 6, [1, 2], "abc"]
    a_list[3] = list(range(0, 5, 2))
    a_list[:2] = ["a", "b"]
    a_list.extend([5, 3, 1])

    print(len(a_list))
    for elem in a_list:
        print(str(elem) + ":" + str(type(elem)))

    del (a_list[3:5])
    a_list.remove("a")
    print(a_list)


def squares(start, end):
    square_lst = []
    for num in range(start, end+1):
        square_lst.append(num**2)
    return square_lst

def digits1(num):
    num_str = str(num)
    digit_lst = []
    for char in num_str:
        digit_lst.append(int(char))
    return digit_lst

def digits2(num):
    digit_lst = []
    while num > 0:
        digit_lst.append(num % 10)
        num = num // 10
    digit_lst.reverse()
    return digit_lst

def word_list(filename):
    file = open(filename, "r")
    words = []
    for line in file:
        words_in_line = line.split()
        words.extend(words_in_line)
    file.close()
    return words

def count_words(filename):
    file = open(filename, "r")
    unique_words = []
    for line in file:
        words_in_line = line.split()
        for word in words_in_line:
            if word not in unique_words:
                unique_words.append(word)
    file.close()
    return len(unique_words)

def main():
    #list_example1()
    #list_example2()
    #list_mutability_example1()
    #list_mutability_example2()

    print(squares(1,10))
    print(digits1(1047))
    print(digits2(1047))

    print(word_list("files/example1.txt"))
    print(count_words("files/example2.txt"))


if __name__ == "__main__":
    main()